/* Implantation de classe Pg */

#include <stdio.h> 
#include <stdlib.h> 
#include <math.h> 
#include <time.h>
#include <sys/unistd.h> 

// definition des types

#include "node.hpp"
#include "pg.hpp"

Pg::Pg() 
  // constructeur
  {
    pop_max = 500;
    perc_selection = 0.4;
    perc_mutation = 0.10;
    perc_crossover = 0.9;
    max_fitness = 999999;
    max_gen = 500;
    prof_init = 3;
    prof_ext = 1;
  }
  
void Pg::SetPopMax(int p)
  // definie la population
{
  pop_max = p;
}
  
void Pg::SetPercSelection(float p)
  // pourcentage de selection naturelle
{
  perc_selection = p;
}

void Pg::SetPercMutation(float p)
  // pourcentage de mutation
{
  perc_mutation = p;
}
  
void Pg::SetPercCrossover(float p)
  // pourcentage de crossover
{
  perc_crossover = p;
}

void Pg::SetMaxGen(int p)
  // nombre maximal de generation
{
  max_gen = p;
}

void Pg::SetMaxFitness(float p)
  // borne  +inf du fitness
{
  max_fitness = p;
}

void Pg::SetProfInit(int p)
  // profondeur d'arbre (taille du genome) des individus crees
{
  prof_init = p;
}

void Pg::SetProfExt(int p)
  // profondeur d'arbre (extension du genome) pour les mutations
{
  prof_ext = p;
}
  

float Pg::MaxFitness()
{
  return max_fitness;
} 

pindividu Pg::GetSuperIndividu()
{
  return superind;
}


void Pg::cycle_pg(void) 
{ 
  int generation = 1; 
  int i,maxg; 

  printf("Debut des cycles de PG\n");
  
  // initialisation de la population 
  
  printf("Initialisation de la population\n");
  
  init_population();
  
  printf("Fin d'initialisation de la population!\n");
  
  
  // PG 
  while (generation <= max_gen) { 
    fitness_population(); 
    // On affichie les meilleurs 
    if ((generation % 10) == 0) { 
	printf("GEN %d\n",generation); 
	
	for (i=0;i<3;i++) {  
	  printf("ind%d=>",i); 
	  aff_prog_gen(pop_tab[i]); 
	} 
	if (pop_tab[0]->fitness<superind->fitness) { 
	  free_pindividu(superind); 
	  superind = clone_pindividu(pop_tab[i]); 
	} 
	// affiche le super individu 
	printf("best=>"); 
	aff_prog_gen(superind); 
    } 
    
    // crossover sur la population pour une nouvelle population 
    crossover(); 
    // mutation sur la population et copie pour le reste 
    //mutation(new_pop_tab,(int)(perc_mutation*pop_max)); 
    
    // nouvelle population 
    for (i=0;i<pop_max;i++) { 
    free_pindividu(pop_tab[i]);  
    pop_tab[i] = new_pop_tab[i]; 
    } 
    
    // generation suivante 
    generation++; 
    
  } 
 
  for (i=0;i<pop_max;i++) { free_pindividu(pop_tab[i]);}  
  

} 


pindividu Pg::creer_individu() 
  // creer un individu quelconque
{ 
  pindividu pi; 
  pi = (pindividu)malloc(sizeof(individu)); 
  pi->pg = creer_arbre(prof_init); 
  pi->fitness = max_fitness; 
  return pi; 
} 
 

pindividu Pg::clone_pindividu(pindividu p) 
  // cloner un individu
{ 
  pindividu res; 
  res=(pindividu)malloc(sizeof(individu)); 
  res->fitness = p->fitness; 
  res->pg = p->pg->clone_nodes(); 
  return res; 
} 
 
  
void Pg::free_pindividu(pindividu p) 
  // tuer un individu
{ 
  p->pg->free_nodes(p->pg); 
  free(p); 
} 
 


void Pg::aff_prog_gen(pindividu pi) 
  // affiche le programme gntique d'un individu et son fitness
{ 
  int i; 
  float f; 
    
  pi->pg->aff_nodes(); 
  printf("/fitness=%f\n",pi->fitness); 
} 

void Pg::quick_sort(pindividu pt[], int bas, int haut) 
    // quick sort pour le tri de la population par fitness
{ 
    int i,j; 
    float x; 
    pindividu y; 
 
    i= bas; 
    j = haut; 
 
    x = pt[(bas+haut)/2]->fitness; 
    do 
      { 
	while(pt[i]->fitness < x) i++; 
	while(x<pt[j]->fitness) j--; 
	if (i<=j) 
	  { 
	    y = pt[i]; 
	    pt[i] = pt[j]; 
	    pt[j] = y; 
	    i++; 
	    j--; 
	  } 
      } 
    while (i<=j); 
 
    if (bas<j) quick_sort(pt,bas,j); 
    if (i<haut) quick_sort(pt,i,haut); 
} 
 
void Pg::fitness_population(void) 
  // calcul le fitness et trier dans l'ordre croissant 
{ 
  int i; 
  for (i=0;i<pop_max;i++) fitness(pop_tab[i]); 
  quick_sort(pop_tab,0,pop_max-1); 
} 

void Pg::mutation_inversion(pindividu p)
  // effectue une mutation, inversion de deux noeuds
{ 
  int nb_noeud; 
  int r1,r2; 
  Node *tn;
  Node *pos1, *pos2; 
 
  tn = new Node();

  // cherche un noeud pour effectuer la mutation 
  nb_noeud = (int)Node::calc_nb_noeuds(p->pg); 
  r1 = (rand() % nb_noeud)+1; 
  r2 = (rand() % nb_noeud)+1; 
  pos1 = Node::pos_node(r1,p->pg); 
  pos2 = Node::pos_node(r2,p->pg); 
  tn->element = pos1->element; 
  pos1->element = pos2->element; 
  pos2->element = tn->element; 
  
  tn->~Node();
  
} 

 
void Pg::mutation_extension(pindividu p)
  // effectue une mutation: supprime un noeud et le remplace par une nouvelle branche
{ 
  int nb_noeud; 
  int r1;
  Node *pos1; 
  
  // cherche un noeud pour effectuer la mutation 
  nb_noeud = (int)Node::calc_nb_noeuds(p->pg); 
  r1 = (rand() % nb_noeud)+1; 
  pos1 = Node::pos_node(r1,p->pg); 
  pos1->fils = creer_arbre(prof_ext); 
} 
 

void Pg::crossover_2ind(pindividu p1, pindividu p2) 
  // effectue un crossover entre 2 individus
{ 
  int nb_noeud1, nb_noeud2; 
  int r1,r2; 
  Node * tn; 
  Node *pos1,*pos2; 
   
  tn = new Node();
 
  nb_noeud1 = (int)Node::calc_nb_noeuds(p1->pg); 
  nb_noeud2 = (int)Node::calc_nb_noeuds(p2->pg); 
 
  r1 = (rand() % nb_noeud1)+1; 
  r2 = (rand() % nb_noeud2)+1; 
    
  pos1 = Node::pos_node(r1,p1->pg); 
  pos2 = Node::pos_node(r2,p2->pg); 
   
  
  tn->element = pos1->element; 
  tn->fils = pos1->fils; 
   
  
  pos1->element= pos2->element; 
  pos1->fils = pos2->fils; 
   
  pos2->element = tn->element; 
  pos2->fils = tn->fils; 
  
  tn->~Node();
} 
 
void Pg::mutation(pindividu t[],int size) 
  // effectue la mutation sur une population
{ 
  int i; 
  
  for (i=0;i<size;i+=2)  
    { 
      mutation_inversion(t[i]); 
      mutation_extension(t[i+1]); 
    } 
  
} 
 
 
void Pg::crossover() 
  // effectue les crossovers dans la population
{ 
  int i; 
  int r1,r2; 
  pindividu c1,c2; 
  int a,select,borne; 
  a = 0; 
  select = (int)(perc_selection*pop_max);
  borne = (int)(perc_crossover*pop_max);
  for(i=0;i<borne;i+=2) 
    { 
      r1 = rand() % select; 
      r2 = rand() % select; 
      c1 = clone_pindividu(pop_tab[r1]); 
      c2 = clone_pindividu(pop_tab[r2]); 
      crossover_2ind(c1,c2); 
      new_pop_tab[i] = c1; 
      new_pop_tab[i+1] = c2; 
    } 
   
  for(i=borne;i<pop_max;i++) new_pop_tab[i]= clone_pindividu(pop_tab[a++]); 
} 
  
void Pg::init_population(void) 
{
  // initialisation de la population
  int i; 
  srand((unsigned) time(NULL)); 
  superind= creer_individu();
  pop_tab[0] = clone_pindividu(superind);
  aff_prog_gen(superind);
  aff_prog_gen(pop_tab[0]);
  for (i=0;i<pop_max;i++) pop_tab[i] = creer_individu();  
} 
 
 
 






